Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::ManualObject::ManualObjectSection Class Reference

Built, renderable section of geometry. More...

`#include <OgreManualObject.h>`

Inheritance diagram for Ogre::ManualObject::ManualObjectSection:

[legend]
List of all members.

## Public Member Functions
| ManualObjectSection (ManualObject *parent, const String &materialName, RenderOperation::OperationType opType)
virtual | ~ManualObjectSection ()
RenderOperation * | getRenderOperation (void)
| Retrieve render operation for manipulation.
const String & | getMaterialName (void) const
| Retrieve the material name in use.
void | setMaterialName (const String &name)
| update the material name in use
const MaterialPtr & | getMaterial (void) const
| Remarks: Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available. .
void | getRenderOperation (RenderOperation &op)
| .
void | getWorldTransforms (Matrix4 *xform) const
| Remarks: If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called. This method will populate xform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms. Note: Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here. See also: Matrix4::isAffine. .
const Quaternion & | getWorldOrientation (void) const
| .
const Vector3 & | getWorldPosition (void) const
| .
Real | getSquaredViewDepth (const Ogre::Camera *) const
| Remarks: Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result. .
const LightList & | getLights (void) const
| Remarks: Directional lights, which have no position, will always be first on this list. .
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual Real | getSquaredViewDepth (const Camera *cam) const =0
| Returns the camera-relative squared depth of this renderable.
virtual bool | getNormaliseNormals (void) const
| Returns whether or not this Renderable wishes the hardware to normalise normals.
virtual const PlaneList & | getClipPlanes () const
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
## Protected Types
typedef std::map< size_t, Vector4 > | CustomParameterMap
## Protected Attributes
ManualObject * | mParent
String | mMaterialName
MaterialPtr | mMaterial
RenderOperation | mRenderOperation
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView
## Static Protected Attributes
static const PlaneList | msDummyPlaneList

## Detailed Description

Built, renderable section of geometry.

Definition at line 361 of file OgreManualObject.h.

## Member Typedef Documentation

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

| Definition at line 285 of file OgreRenderable.h.

## Constructor & Destructor Documentation

Ogre::ManualObject::ManualObjectSection::ManualObjectSection | ( | ManualObject * | parent,
|  | const String & | materialName,
|  | RenderOperation::OperationType | opType
| ) |

virtual Ogre::ManualObject::ManualObjectSection::~ManualObjectSection | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) | const`[virtual, inherited]`

  | Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows. Remarks: This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter. You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case. Parameters:
  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.
Reimplemented in Ogre::SubEntity. Definition at line 252 of file OgreRenderable.h.

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const`[virtual, inherited]`

| Method which reports whether this renderable would normally cast a shadow. Remarks: Subclasses should override this if they could have been used to generate a shadow. Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity. Definition at line 187 of file OgreRenderable.h.

virtual const PlaneList& Ogre::Renderable::getClipPlanes | ( |  | ) | const`[virtual, inherited]`

| Definition at line 179 of file OgreRenderable.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

  | Gets the custom value associated with this Renderable at the given index. Parameters:
  | @see | setCustomParaemter for full details.
Definition at line 213 of file OgreRenderable.h. References OGRE_EXCEPT.

const LightList& Ogre::ManualObject::ManualObjectSection::getLights | ( | void |  | ) | const`[virtual]`

| Remarks: Directional lights, which have no position, will always be first on this list. . Implements Ogre::Renderable.

const MaterialPtr& Ogre::ManualObject::ManualObjectSection::getMaterial | ( | void |  | ) | const`[virtual]`

| Remarks: Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available. . Implements Ogre::Renderable.

const String& Ogre::ManualObject::ManualObjectSection::getMaterialName | ( | void |  | ) | const

| Retrieve the material name in use. Definition at line 377 of file OgreManualObject.h.

virtual bool Ogre::Renderable::getNormaliseNormals | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this Renderable wishes the hardware to normalise normals. Reimplemented in Ogre::SubEntity. Definition at line 171 of file OgreRenderable.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

| Returns the number of world transform matrices this renderable requires. Remarks: When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity. Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity. Definition at line 111 of file OgreRenderable.h.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Reimplemented in Ogre::BorderRenderable. Definition at line 277 of file OgreRenderable.h.

void Ogre::ManualObject::ManualObjectSection::getRenderOperation | ( | RenderOperation & | op | ) | `[virtual]`

| . Implements Ogre::Renderable.

RenderOperation* Ogre::ManualObject::ManualObjectSection::getRenderOperation | ( | void |  | ) |

| Retrieve render operation for manipulation.

virtual Real Ogre::Renderable::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[pure virtual, inherited]`

| Returns the camera-relative squared depth of this renderable. Remarks: Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result. Implemented in Ogre::BillboardChain, Ogre::BillboardSet, Ogre::BorderRenderable, Ogre::Frustum, Ogre::InstancedGeometry::GeometryBucket, Ogre::Node, Ogre::OverlayElement, Ogre::Rectangle2D, Ogre::ShadowRenderable, Ogre::StaticGeometry::GeometryBucket, Ogre::SubEntity, and Ogre::WireBoundingBox.

Real Ogre::ManualObject::ManualObjectSection::getSquaredViewDepth | ( | const Ogre::Camera * |  | ) | const

| Remarks: Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result. .

virtual Technique* Ogre::Renderable::getTechnique | ( | void |  | ) | const`[virtual, inherited]`

| Retrieves a pointer to the Material Technique this renderable object uses. Remarks: This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using. Reimplemented in Ogre::InstancedGeometry::GeometryBucket, Ogre::StaticGeometry::GeometryBucket, and Ogre::SubEntity. Definition at line 73 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

| Returns whether or not to use an 'identity' projection. Remarks: Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. See also: Renderable::setUseIdentityProjection Definition at line 136 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

| Returns whether or not to use an 'identity' view. Remarks: Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. See also: Renderable::setUseIdentityView Definition at line 161 of file OgreRenderable.h.

const Quaternion& Ogre::ManualObject::ManualObjectSection::getWorldOrientation | ( | void |  | ) | const`[virtual]`

| . Implements Ogre::Renderable.

const Vector3& Ogre::ManualObject::ManualObjectSection::getWorldPosition | ( | void |  | ) | const`[virtual]`

| . Implements Ogre::Renderable.

void Ogre::ManualObject::ManualObjectSection::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[virtual]`

| Remarks: If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called. This method will populate xform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms. Note: Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here. See also: Matrix4::isAffine. . Implements Ogre::Renderable.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) | `[inherited]`

  | Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters. Remarks: Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter. Parameters:
  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.
Definition at line 204 of file OgreRenderable.h.

void Ogre::ManualObject::ManualObjectSection::setMaterialName | ( | const String & | name | ) |

| update the material name in use

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

  | Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Parameters:
  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.
Definition at line 269 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

| Sets whether or not to use an 'identity' projection. Remarks: Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false. See also: Renderable::getUseIdentityProjection Definition at line 122 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

| Sets whether or not to use an 'identity' view. Remarks: Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false. See also: Renderable::getUseIdentityView Definition at line 147 of file OgreRenderable.h.

## Member Data Documentation

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

| Definition at line 286 of file OgreRenderable.h.

MaterialPtr Ogre::ManualObject::ManualObjectSection::mMaterial`[mutable, protected]`

| Definition at line 366 of file OgreManualObject.h.

String Ogre::ManualObject::ManualObjectSection::mMaterialName`[protected]`

| Definition at line 365 of file OgreManualObject.h.

ManualObject* Ogre::ManualObject::ManualObjectSection::mParent`[protected]`

| Definition at line 364 of file OgreManualObject.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

| Definition at line 287 of file OgreRenderable.h.

RenderOperation Ogre::ManualObject::ManualObjectSection::mRenderOperation`[protected]`

| Definition at line 367 of file OgreManualObject.h.

const PlaneList Ogre::Renderable::msDummyPlaneList`[static, protected, inherited]`

| Definition at line 284 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

| Definition at line 288 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

| Definition at line 289 of file OgreRenderable.h.

The documentation for this class was generated from the following file:

- OgreManualObject.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:47:02 2008